#include <cstdio>
#include <vector>

const int MAX_N = 100 + 5;
const int MAX_P = 10 + 5;

int N, M, P;
char label[MAX_N];
char path[MAX_P];
std :: vector<int> g[MAX_N];

int dp[MAX_N][MAX_P];
int rec(int node, int pos)
{
	if(pos == P)	return 1;
	int &ret = dp[node][pos];
	if(ret != -1)	return ret;
	int res = 0;
	for(int i = 0; i < g[node].size(); i ++)	if( label[ g[node][i] ] == path[pos] )	res += rec(g[node][i], pos + 1);
	return ret = res;
}

int main()
{
	scanf("%d %d\n", &N, &M);
	scanf("%s\n", label);
	for(int i = 0; i < M; i ++)
	{
		int p, q;
		scanf("%d %d\n", &p, &q);
		p --, q --;
		g[p].push_back(q);
		if(p != q)	g[q].push_back(p);
	}
	scanf("%s", path);
	P = strlen(path);
	memset(dp, -1, sizeof(dp));
	int res = 0;
	for(int i = 0; i < N; i ++)	if( label[i] == path[0] )	res += rec(i, 1);
	printf("%d\n", res);
    return 0;
}
