#include <iostream>
#include <set>
#include <map>
using namespace std;

typedef long long LL;

const int MAX_N = 32;

int N;
LL dig[MAX_N];
set<LL> used;
map<LL, bool> visited[MAX_N];

void Read()
{
	used.clear();
	for(int i = 0; i < MAX_N; i ++)
		visited[i].clear();
	
	cin >> N;
	
	for(int i = 0; i < N; i ++)
		cin >> dig[i];
}

void rec(int n, LL res)
{
	if(visited[n][res]) return;
	visited[n][res] = true;
	
	if(n == N - 1)
	{
		used.insert(res);
		
		return;
	}
	
	for(int i = 0; n + i < N - 1 ; i ++)
	{
	LL temp = dig[n + 1];
		
		for(int j = n + 1; j <= n + i; j ++)
			temp = temp * dig[j + 1];
		
		rec(n + i + 1, res + temp);
		rec(n + i + 1, res - temp);
	}
}

void Solve()
{
	for(int i = 0; i <= N - 1 ; i ++)
	{
	LL temp = dig[0];
		
		for(int j = 1; j <= i; j ++)
			temp = temp * dig[j];
		
		rec(i, temp);
	}
}

void Write()
{
	cout << used.size() << "\n";
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
