/*
TASK: triangles
LANG: C++
*/
#include <cstdio>
#include <algorithm>
#include <iostream>
#include <cmath>
#include <vector>
#define SQR(a) ((a)*(a))
using namespace std;

struct point{ int x,y; };
struct mas{ point c[3]; double s;  };
int N, res[1024];
vector< mas > v(1024);

bool CMP( mas p1, mas p2 ){ return p1.s > p2.s; }
bool CMP1( point p1, point p2 ){ return p1.y/double(p1.x) < p2.y/double(p2.x); }

int main(){
    
    scanf("%d",&N);
    int i,j;
    double aa,bb,cc,pp,ss;
    for(i=0; i<N; i++){
        scanf("%d%d%d%d%d%d",&v[i].c[0].x, &v[i].c[0].y, &v[i].c[1].x, &v[i].c[1].y, &v[i].c[2].x, &v[i].c[2].y);
        aa = sqrt( SQR(v[i].c[0].x-v[i].c[1].x) + SQR(v[i].c[0].y-v[i].c[1].y) );
        bb = sqrt( SQR(v[i].c[0].x-v[i].c[2].x) + SQR(v[i].c[0].y-v[i].c[2].y) );
        cc = sqrt( SQR(v[i].c[2].x-v[i].c[1].x) + SQR(v[i].c[2].y-v[i].c[1].y) );
        pp = (aa+bb+cc)/2.0;
        ss = sqrt( pp*(pp-aa)*(pp-bb)*(pp-cc) );
        v[i].s = ss;
        sort( v[i].c , v[i].c+3 , CMP1 );
    }
    sort ( v.begin(), v.end(), CMP );
    //for(i=0; i<N; i++) cout << i<<" : "<<v[i].c[0].x<<" "<< v[i].c[0].y<<" "<<v[i].c[1].x<<" "<<v[i].c[1].y<<" "<<v[i].c[2].x<<" "<<v[i].c[2].y<<endl;
    int a1,a2,b1,b2;
    int z1,z2,z3,f1,f2,f3;
    for(i=1; i<N; i++)
    {
     for(j=i-1; j>=0; j--)
      {
            
            f1 = v[j].c[0].x*( v[j].c[1].y-v[i].c[0].y ) + v[j].c[1].x*( v[i].c[0].y-v[j].c[0].y ) + v[i].c[0].x*( v[j].c[0].y-v[j].c[1].y );
            f2 = v[j].c[0].x*( v[j].c[1].y-v[i].c[1].y ) + v[j].c[1].x*( v[i].c[1].y-v[j].c[0].y ) + v[i].c[1].x*( v[j].c[0].y-v[j].c[1].y );
            f3 = v[j].c[0].x*( v[j].c[1].y-v[i].c[2].y ) + v[j].c[1].x*( v[i].c[2].y-v[j].c[0].y ) + v[i].c[2].x*( v[j].c[0].y-v[j].c[1].y );
            //cout<<i<<" "<<j<<" "<<f1<<" "<<f2<<" "<<f3<<endl;
            if( f1>=0 && f2>=0 && f3>=0 ) z1=1;
            else if( f1<=0 && f2<=0 && f3<=0 ) z1=2;
            else goto next;
            
            f1 = v[j].c[1].x*( v[j].c[2].y-v[i].c[0].y ) + v[j].c[2].x*( v[i].c[0].y-v[j].c[1].y ) + v[i].c[0].x*( v[j].c[1].y-v[j].c[2].y );
            f2 = v[j].c[1].x*( v[j].c[2].y-v[i].c[1].y ) + v[j].c[2].x*( v[i].c[1].y-v[j].c[1].y ) + v[i].c[1].x*( v[j].c[1].y-v[j].c[2].y );
            f3 = v[j].c[1].x*( v[j].c[2].y-v[i].c[2].y ) + v[j].c[2].x*( v[i].c[2].y-v[j].c[1].y ) + v[i].c[2].x*( v[j].c[1].y-v[j].c[2].y );
            //cout<<i<<" "<<j<<" "<<f1<<" "<<f2<<" "<<f3<<endl;
            if( f1>=0 && f2>=0 && f3>=0 ) z2=1;
            else if( f1<=0 && f2<=0 && f3<=0 ) z2=2;
            else goto next;
            
            f1 = v[j].c[2].x*( v[j].c[0].y-v[i].c[0].y ) + v[j].c[0].x*( v[i].c[0].y-v[j].c[2].y ) + v[i].c[0].x*( v[j].c[2].y-v[j].c[0].y );
            f2 = v[j].c[2].x*( v[j].c[0].y-v[i].c[1].y ) + v[j].c[0].x*( v[i].c[1].y-v[j].c[2].y ) + v[i].c[1].x*( v[j].c[2].y-v[j].c[0].y );
            f3 = v[j].c[2].x*( v[j].c[0].y-v[i].c[2].y ) + v[j].c[0].x*( v[i].c[2].y-v[j].c[2].y ) + v[i].c[2].x*( v[j].c[2].y-v[j].c[0].y );
            //cout<<i<<" "<<j<<" "<<f1<<" "<<f2<<" "<<f3<<endl;
            if( f1>=0 && f2>=0 && f3>=0 ) z3=1;
            else if( f1<=0 && f2<=0 && f3<=0 ) z3=2;
            else goto next;
            
            if(z1!=z2||z1!=z3||z2!=z3) goto next;
            //cout << i << " fits in " << j << endl;
            res[i] = res[j]+1;
            break;
            next:;
        }
        //system("pause");
    }
    int maxi=0;
    for(i=0; i<N; i++) maxi=max(maxi,res[i]);
    cout<<maxi+1<<endl;
}
