#include<iostream>
#include<vector>
using namespace std;
struct point
{
	int x,y;
};
struct triangle
{
	point a,b,c;
};
int orient(point a,point b,point c)
{
	//int is=(a.x*b.y+b.x*c.y+c.x*a.y-a.y*b.x-b.y*c.x-c.y*a.x);                                                 
	int is=(a.x+b.x)*(a.y-b.y)+(b.x+c.x)*(b.y-c.y)+(c.x+a.x)*(c.y-a.y);
	if(is>0) return 1;
	if(is==0) return 0;
	if(is<0) return -1;
}
int isin(triangle k,triangle l)
{
	int is1,is2,is3;
	is1=orient(k.a,k.b,l.a);
	is2=orient(k.b,k.c,l.a);
	is3=orient(k.c,k.a,l.a);
	if(!(is1*is2*is3)||(is1!=is2)||(is2!=is3)||(is3!=is1)) return 0;
	is1=orient(k.a,k.b,l.b);
	is2=orient(k.b,k.c,l.b);
	is3=orient(k.c,k.a,l.b);
	if(!(is1*is2*is3)||(is1!=is2)||(is2!=is3)||(is3!=is1)) return 0;
	is1=orient(k.a,k.b,l.c);
	is2=orient(k.b,k.c,l.c);
	is3=orient(k.c,k.a,l.c);
	if(!(is1*is2*is3)||(is1!=is2)||(is2!=is3)||(is3!=is1)) return 0;
	return 1;
}
int n,maxx=0;
triangle t[1020];
vector <int> a[1020];
void bfs(int x)
{
	vector <int> stek;
	int now=0,level=0,levelend=0;
	stek.push_back(x);
	while(now<stek.size())
	{
		int current=stek[now];
		if(now==levelend) {level++;levelend=stek.size();}
		int m=a[current].size();
		for(int i=0;i<m;i++)
		stek.push_back(a[current][i]);
		now++;
	}
	if(maxx<level) maxx=level;
}
int main()
{
	
	cin>>n;
	for(int i=0;i<n;i++)
	{
	//cin>>t[i].a.x>>t[i].a.y>>t[i].b.x>>t[i].b.y>>t[i].c.x>>t[i].c.y;
	scanf("%d%d%d%d%d%d",&t[i].a.x,&t[i].a.y,&t[i].b.x,&t[i].b.y,&t[i].c.x,&t[i].c.y);
	for(int j=0;j<i;j++)
	{
	if(isin(t[i],t[j])) a[i].push_back(j);
	if(isin(t[j],t[i])) a[j].push_back(i);
	}
	}
	for(int i=0;i<n;i++)
	bfs(i);
	cout<<maxx<<endl;
	//system("pause");
	return 0;
}
/*
5
-1 -1 0 3 3 0
0 0 1 0 0 1
6 0 4 1 5 3
5 0 5 2 7 2
0 6 -8 -4 10 -4

	for(int i=0;i<n;i++)
	{
	cout<<i+1<<":  ";
	for(int j=0;j<a[i].size();j++)
	cout<<a[i][j]+1<<" ";
	cout<<endl;
	}
*/