#include <iostream>
#include <cmath>
typedef unsigned long long int64;

int n;
struct matr
{
  int64 m[1024][1024];
  matr& operator*=(matr &arg)
  {
    static matr buf1;
    memcpy(&buf1,this,sizeof(buf1));
    for(int i=0;i<n;++i)
      for(int j=0;j<n;++j)
      {
        m[i][j]=0;
        for(int k=0;k<n;++k)
        {
          if(&arg!=this)
            m[i][j]+=buf1.m[i][k]*arg.m[k][j];
          else
            m[i][j]+=buf1.m[i][k]*buf1.m[k][j];
        }
      }
    return *this;
  }
  void make_one()
  {
    for(int i=0;i<n;++i)
      for(int j=0;j<n;++j)
        m[i][j]=0;
    for(int i=0;i<n;++i)
      m[i][i]=1;
  }
  void make_multip_matr()
  {
    for(int i=0;i<n;++i)
      for(int j=0;j<n;++j)
        m[i][j]=i>=j-2?1:0;
  }
};

matr rez,multip;


int main()
{
  int k;
  std::cin>>n>>k;
  if(n==k||k==1)
  {
    std::cout<<1<<std::endl;
  }
  else if(n==k+1)
  {
    std::cout<<1<<std::endl;
  }
  else if(n-k<=k)
  {
    long double ret=1;
    k=n-k+1;
    while(--k)
      ret*=k;
    std::cout<<ret<<std::endl;
  }
  else if(n<66)
  {
    rez.make_one();
    multip.make_multip_matr();
    for(int i=10;i+1;--i)
    {
      rez*=rez;
      if(k&1<<i)
        rez*=multip;
    }
    std::cout<<rez.m[n-1][n-1]<<std::endl;
  }
  else
  {
    int i,j;
    for(i=0;i<=n;++i)
      rez.m[0][i]=rez.m[i][0]=1;
    for(i=1;i<n;++i)
      for(j=1;j<k;++j)
        rez.m[i][j]=rez.m[i-1][j-1]+j*rez.m[i][j-1];
      std::cout<<floor(pow((rez.m[n-1][k-1]),66.0/(n*n)))<<std::endl;
  }
  return 0;
}