#include <algorithm>
#include <iostream>
#include <sstream>
#include <vector>
using namespace std;

int N;
vector<int> digs, results;

template<class T> void print(T v) {
  for(int i = 0; i < v.size(); i++) cout << v[i] << " ";
}

vector<char> ops;

int eval() {
  int i=0, res=0;
  while(i < N) {
    int toAdd = digs[i];
    char op=(i==0?'+':ops[i-1]);
    if(op=='-')toAdd=-toAdd;
    i++;
    while(ops[i-1]=='*' && i<N) { toAdd*=digs[i++]; }
    res+=toAdd;
  }
  return res;
}

void gen(char c) {
  ops.push_back(c);
  if(ops.size()<N-1) {
    gen('+');
    gen('-');
    gen('*');
  } else {
    results.push_back(eval());
  }
  ops.pop_back();
}

int main() {
//  stringstream in("13 1 2 3 4 5 6 7 8 9 8 7 6 5");
//  stringstream in("3 1 2 2");
//  stringstream in("6 1 2 3 4 5 6");
  cin >> N;
  digs.resize(N);
  for(int i = 0; i < N; i++) cin >> digs[i];

  gen('+');gen('-');gen('*');

  sort(results.begin(), results.end());
  cout << unique(results.begin(), results.end()) - results.begin() << endl; // can be optimized, i just want the count
// 531441 15324
}
