#include <algorithm>
#include <numeric>
#include <iostream>
#include <vector>
using namespace std;

int numGroups, numGuys;

vector<vector<int> > confs;

vector<int> cur;

bool none_eq() {
  for(int i = 0; i < confs.size(); i++) {
    if(confs[i]==cur) return false;
  }
  return true;
}

void gen(int a) {
  cur.push_back(a);
  if(cur.size()<numGroups) {
    for(int i=a;i<numGuys;i++) {
      gen(i);
    }
  } else {
    if(accumulate(cur.begin(), cur.end(), 0)==numGuys) {
      if(none_eq()) confs.push_back(cur);
    }
  }
  cur.pop_back();
}

int main() {
  cin >> numGuys >> numGroups;

  for(int i=1;i<numGuys;i++) {
    gen(i);
  }
  cout<<confs.size()<<endl;
}
