#include <cstdio>
#include <vector>

using namespace std;

#define _(n, k, i) vec[n][flagz[n][k] + i - 1]

#define f(i, n) for (int i = 0; i < n; ++i)
#define fo(i, a, b) for (int i = a; i <= b; ++i)

#define MAX_N 805
#define MAX_K 805

int flagz[MAX_N][MAX_K];
vector <long long> vec [MAX_N];

int N, K;

void read()
{
  scanf ("%d %d", &N, &K);
}

inline void calc (int x, int a, int b)
{
  if (a == 1 || x == a || x == a + 1) vec[x].push_back(1);
  else if (b == 1 && (a << 1) > x) vec[x].push_back(_(2*(x-a), (x-a), b));
  else if (a == 2)      vec[x].push_back((x >> 1) - b + 1);
  else {
    int r = 0;
    for (int i = b; (a-1) * i <= x-i; ++i) {
      r += _(x-i, a-1, i);
    }
    vec[x].push_back(r);
  }
}

void solve()
{
  int c;
  fo (x, 1, N) {
    c = 0;
    fo (i, 1, min(x, K)) {
      flagz[x][i] = c;
      for (int j = 1; i*j <= x; ++j) {
        calc (x, i, j);
        ++c;
      }
    }
  }
}

void write()
{
  printf ("%d\n", _(N, K, 1));
}


int main ()
{
  read ();
  solve();
  write();

  return 0;
}