#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <climits>

#define ll long long

inline int min(int a, int b) {
	return a < b ? a : b;
}

int fn, fk;

ll memo[1024][1024];

ll memrec(int s, int m) {
	if(s == 0) return 1;
	if(memo[s][m]) return memo[s][m];
	ll res = 0;
	for(int i = 1; i <= min(s, m); ++i) {
		res += memrec(s-i, i);
	}
	return memo[s][m] = res;
}


ll rec(int k, int n, int m) {
	//printf("call %d %d %d\n", k, n, m);
	if(k*m < n) return 0;
	if(k*m == n) return 1;
	if(k == 1) {
		return n <= m;
	}
	ll res = 0;
	for(int i = min(n-1, m); i >= 1; --i) {
		res += rec(k-1, n-i, i);
	}
	
	/*if(n >= k && n < 2*k) {
		printf("tryopt %d %d %d\n", k, n, m);
		printf("\t%lld\n", memrec(n-k, m));
		printf("\t%lld\n", res);
		//return memrec(n-k, m);
	}*/
	return res;
}



int main() {
	//printf("%lld\n", rec(2, 2, 2));
	//return 0;
	//
	scanf("%d%d", &fn, &fk);
	if(fn <= 2*fk) {
		//printf("fast\n");
		printf("%lld\n", memrec(fn-fk, fn-fk));
	} else {
		printf("%lld\n", rec(fk, fn, fn-fk+1));
	}
	return 0;
}
