#include <stdio.h>

const unsigned max_town = 1024;
const unsigned max_num = 1<<16;

int dist[max_town], pos_amb[max_town];

int n, k, min_d = max_num, ambs;

int farthest_dist = 0;//ony used by farthest

int d(int a, int b)
{
  if(a>b)
    return dist[a]-dist[b];
  else
    return dist[b]-dist[a];
}

int farthest()
{
  farthest_dist = 0;
  int farthest_index;
  for(int i = 0; i < n; ++i)
  {
    int local_min = max_num;
    for(int j = 0; j < k-ambs; ++j)
    {
     if(d(i, pos_amb[j]) < local_min)
      local_min = d(i, pos_amb[j]);
    }
    if(farthest_dist < local_min)
    {
      farthest_dist = local_min;
      farthest_index = i;
    }
  }
  return farthest_index;
}

int main()
{
  int l;
  scanf("%d %d", &n, &k);
  for(int i = 1; i < n; ++i)
  {
    scanf("%d", &l);
    dist[i] = dist[i-1] + l;
  }
  for(int i = 0; i < n; ++i)
  {
    for(int j = 0; j < k; ++j) pos_amb[j] = -1;
    pos_amb[0] = i;
    ambs = k-1;
    while(ambs>0)
    {
      pos_amb[k-ambs] = farthest();
      --ambs;
    }
    farthest();
    if(farthest_dist < min_d) min_d = farthest_dist;
  }
  printf("%d\n", min_d);
  return 0;
}
