/*
codr: timiter
task: triangles
lang: C++
*/

#include <cstdio>
#include <cmath>

using namespace std;

int n;
int a[1024][1024], b[1024], x[1024][3], y[1024][3], g, max = 0;
double pi, d[4];

void ddfs(int, int);

int main()
{
  pi = atan2(0, -1);
  int i, j;
  scanf("%d", &n);
  for (i = 0; i < n; i++)
  {
    b[i] = 0;
    for (j = 0; j < n; j++)
    {
      a[i][j] = 0;
    }
  }
  for (i = 0; i < n; i++)
  {
    scanf("%d %d %d %d %d %d", &x[i][0], &y[i][0], &x[i][1], &y[i][1], &x[i][2], &y[i][2]);
  }
  for (i = 0; i < n; i++)
  {
    for (j = 0; j < n; j++)
    {
      if ((x[i][0] == x[j][0] && y[i][0] == y[j][0]) ||
          (x[i][0] == x[j][1] && y[i][0] == y[j][1]) ||
          (x[i][0] == x[j][2] && y[i][0] == y[j][2]) ||
          (x[i][1] == x[j][0] && y[i][1] == y[j][0]) ||
          (x[i][1] == x[j][1] && y[i][1] == y[j][1]) ||
          (x[i][1] == x[j][2] && y[i][1] == y[j][2]) ||
          (x[i][2] == x[j][0] && y[i][2] == y[j][0]) ||
          (x[i][2] == x[j][1] && y[i][2] == y[j][1]) ||
          (x[i][2] == x[j][2] && y[i][2] == y[j][2]))
      {
        continue;
      }
      g = 0;
      d[0] = atan2(y[j][1] - y[j][0], x[j][1] - x[j][0]);
      d[1] = atan2(y[j][2] - y[j][0], x[j][2] - x[j][0]);
      d[1] -= d[0];
      while (d[1] < -pi)
      {
        d[1] += 2 * pi;
      }
      while (d[1] > pi)
      {
        d[1] -= 2 * pi;
      }
      d[2] = atan2(y[i][0] - y[j][0], x[i][0] - x[j][0]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[2] = atan2(y[i][1] - y[j][0], x[i][1] - x[j][0]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[2] = atan2(y[i][2] - y[j][0], x[i][2] - x[j][0]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[0] = atan2(y[j][2] - y[j][1], x[j][2] - x[j][1]);
      d[1] = atan2(y[j][0] - y[j][1], x[j][0] - x[j][1]);
      d[1] -= d[0];
      while (d[1] < -pi)
      {
        d[1] += 2 * pi;
      }
      while (d[1] > pi)
      {
        d[1] -= 2 * pi;
      }
      d[2] = atan2(y[i][0] - y[j][1], x[i][1] - x[j][1]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[2] = atan2(y[i][1] - y[j][1], x[i][1] - x[j][1]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[2] = atan2(y[i][2] - y[j][1], x[i][2] - x[j][1]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[0] = atan2(y[j][0] - y[j][2], x[j][0] - x[j][2]);
      d[1] = atan2(y[j][1] - y[j][2], x[j][1] - x[j][2]);
      d[1] -= d[0];
      while (d[1] < -pi)
      {
        d[1] += 2 * pi;
      }
      while (d[1] > pi)
      {
        d[1] -= 2 * pi;
      }
      d[2] = atan2(y[i][0] - y[j][2], x[i][0] - x[j][2]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[2] = atan2(y[i][1] - y[j][2], x[i][1] - x[j][2]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      d[2] = atan2(y[i][2] - y[j][2], x[i][2] - x[j][2]);
      d[2] -= d[0];
      while (d[2] < -pi)
      {
        d[2] += 2 * pi;
      }
      while (d[2] > pi)
      {
        d[2] -= 2 * pi;
      }
      if (d[2] == pi || d[2] == -pi)
      {
        d[2] = 0;
      }
      if (d[1] * d[2] > 0)
      {
        g++;
      }
      if (g == 9)
      {
        a[j][i] = 1;
        b[i]++;
      }
    }
  }
  for (i = 0; i < n; i++)
  {
    if (b[i] == 0)
    {
      ddfs(i, 1);
    }
  }
  printf("%d\n", max);
  return 0;
}

void ddfs(int c, int l)
{
  if (l > max)
  {
    max = l;
  }
  int i;
  for (i = 0; i < n; i++)
  {
    if (a[c][i] == 1)
    {
      ddfs(i, l + 1);
    }
  }
}
