/*
PROB: expr
ID: Nikolay Hubanov
*/

#include <iostream>
#include <cstdio>
#include <stack>
#include <set>

using namespace std;

int n,rpnPos,to;
int expr[64];
int RPN[64];
stack<int> op;
set<int> saveThem;

bool toPop(int &a,int &b)
{ return b==-3?(a==-3):1; }

void createRPN()
{
 int tmp,cur;
 op=stack<int> ();
 rpnPos=0;
 for(int i=0;i<to;i++)
    {tmp=expr[i];
     if(i&1) {
              while(!op.empty())
              { cur=op.top();
                if(toPop(cur,tmp)) { op.pop(); RPN[rpnPos++]=cur; }
                else break;
              }
              op.push(tmp);
             }
     else RPN[rpnPos++]=tmp;
    }
    
 while(!op.empty())
 { RPN[rpnPos++]=op.top(); op.pop(); }
}

void showRPN()
{cout<<"----------------------"<<endl;
 int i;
 for(int i=0;i<rpnPos;i++)
    if(RPN[i]>=0) cout<<RPN[i];
    else { if(RPN[i]==-1) cout<<'+';
           else if(RPN[i]==-2) cout<<'-';
                else if(RPN[i]==-3) cout<<'*';
         }
 cout<<endl;    
}

int x,y;
void solveRPN()
{
 op=stack<int> ();
 for(int i=0;i<rpnPos;i++)
   {
    if(RPN[i]>=0) op.push(RPN[i]);
    else {
          y=op.top(); op.pop();
          x=op.top(); op.pop();
          
          if(RPN[i]==-1) op.push(x+y);
          else if(RPN[i]==-2) op.push(x-y);
               else if(RPN[i]==-3) op.push(x*y); 
         }
   }    
 saveThem.insert(op.top());
}

void genOperators(int pos)
{
 if(pos>=2*(n-1)) { createRPN(); solveRPN(); return; }    
 expr[pos]=-1; genOperators(pos+2);
 expr[pos]=-2; genOperators(pos+2);
 expr[pos]=-3; genOperators(pos+2);
}

int main()
{
 scanf("%d",&n); to=2*n-1;
 for(int i=0;i<2*n;i+=2)
     scanf("%d",&expr[i]);
 
 genOperators(1);
 
 cout<<saveThem.size()<<endl;
 
 return 0;
}
