#include <cstdio>
#include <set>

const int MAX_N = 20 + 5;

std :: set<long long> res;

int N, OP;
int a[MAX_N];
char op[MAX_N];
char ch[] = {'-', '+', '*'};
int pr[256];

char op_stack[MAX_N];
int op_top;
long long dig[MAX_N];
int dig_top;
long long eval()
{
	dig_top = 0;
	op_top = 0;
	op_stack[op_top ++] = '$';
	for(int i = 0; i < OP; i ++)
	{
		dig[dig_top ++] = a[i];
		while( pr[ op_stack[op_top - 1] ] >= pr[op[i]] )
		{
			long long second = dig[-- dig_top];
			long long first = dig[-- dig_top];
			long long res;
			char cur = op_stack[-- op_top];
			if( cur == '+' )		res = first + second;
			else if( cur == '-' )	res = first - second;
			else 					res = first * second;
			dig[dig_top ++] = res;
		}
		op_stack[op_top ++] = op[i];
	}
	dig[dig_top ++] = a[N - 1];
	while( op_stack[op_top - 1] != '$' )
	{
		long long second = dig[-- dig_top];
		long long first = dig[-- dig_top];
		long long res;
		char cur = op_stack[-- op_top];
		if( cur == '+' )		res = first + second;
		else if( cur == '-' )	res = first - second;
		else 					res = first * second;
		dig[dig_top ++] = res;
	}
	res.insert(dig[dig_top - 1]);
}

void rec(int pos)
{
	if(pos == OP)
	{
		eval();
		return;
	}
	op[pos] = '+';	rec(pos + 1);
	if(a[pos + 1])	op[pos] = '-';	rec(pos + 1);
	op[pos] = '*';	rec(pos + 1);
}

int main()
{
	scanf("%d", &N);
	OP = N - 1;
	for(int i = 0; i < N; i ++)	scanf("%d", &a[i]);
	pr['+'] = pr['-'] = 1;
	pr['*'] = 2;
	rec(0);
	printf("%d\n", res.size());
    return 0;
}
