#include<cstdio>
#include<vector>
#define pb push_back
using namespace std;
//declarations
long n,k,dist[1024],ind[2048],log,makz,prev;
vector<long> v;

//update index tree
void update(int pos,int val)
{ pos+=log;
  long x=pos;
  while(x!=1)
   { ind[x]+=val;
     x/=2;
   }
}



//index tree query
int query(long left,long right)
{ long rezult=0,l=left+log,r=right+log;
  while(1)
   { rezult+=ind[l]+ind[r];
     l/=2,l++,r/=2,r--;
     if(r<=l) break;
   }
  return rezult; 
}



//The Check
void check()
{ long m=0;
  for(int i=0; i<=k-1; i++)
   m=v[i]>m?v[i]:m;
  makz=m>makz?m:makz; 
}



//DFS
void rec(int pos,int kk)
{ if(kk==k) {check();return;}
  for(int i=pos+1; i<=n; i++)
   { long cost;
     cost=query(pos,i);
     if(cost<=makz) v.pb(cost),rec(pos+1,kk+1),v.pop_back();
   }
}



//solution
void sol()
{ for(int i=1; i<=k-1; i++)
   if(makz<dist[i]) makz=dist[i];
  rec(0,0);
  printf("%d\n",makz);
}


//input + finding the next pow of 2 upper
void vhod()
{ scanf("%d%d",&n,&k);
  long apf=1;
  for(int i=1; i<=32; i++)
   { apf*=2; if(apf>=n) {log=apf; break;}}
     update(0,dist[0]);
  for(int i=1; i<n; scanf("%d",&dist[i]),update(i,dist[i]),i++);
  sol();
  
}



int main()
{ vhod();
  return 0;
}
