#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 7;
const int MAXL = 1 << 5;

int n , m;
char f[MAXN];
char t[MAXN];
int dp[MAXN][MAXN];
vector < int > a[MAXN][MAXL];

void read() {
    int x , y;
    
    scanf ( "%d%d" , &n , &m );
    scanf ( "%s" , f + 1 );
    while ( m -- ) {
        scanf ( "%d%d" , &x , &y );
        
        a[x][ f[y] - 'A' ].push_back ( y );
        a[y][ f[x] - 'A' ].push_back ( x );
    }
    
    scanf ( "%s" , t );
}

int go ( int node , int p ) {
    if ( dp[node][p] != -1 ) return dp[node][p];
    if ( t[p] == '\0' ) return 1;
    int i;
    int ans = 0;
    
    for (i = 0; i < (int)a[node][ t[p] - 'A' ].size(); i++) 
        ans += go ( a[node][ t[p] - 'A' ][i] , p + 1 );
        
    return dp[node][p] = ans;
}

void solve() {
    int ans = 0;
    int i;
    
    memset ( dp , -1 , sizeof dp );
    
    for (i = 1; i <= n; i++)
        if ( f[i] == t[0] )
            ans += go ( i , 1 );
            
    printf ( "%d\n" , ans );
}

int main() {
    read();
    solve();
    
    return 0;
}
