#include <iostream>
#include <string>
using namespace std;

unsigned long long N, M, word_len, paths = 0;
unsigned char A[100][100] = {0};
char names[128];
char word[16];


void solve(int cross, int level)
{
  int cross_queue[100], queue_end = 0;
  for(int i = 0; i < N; i++)
  {
    if(A[cross][i] && names[i] == word[level])
      cross_queue[queue_end++] = i;
  }

  if(level == word_len - 1)
  {
    paths += queue_end;
    return;
  }

  for(int i = 0; i < queue_end; i++)
  {
    solve(cross_queue[i], level + 1);
  }
}
int main()
{
  cin >> N >> M;
  cin >> names;

  int i_, j_;
  for(int i = 0; i < M; i++)
  {
      cin >> i_ >> j_;
      A[i_ - 1][j_ - 1] = 1;
      A[j_ - 1][i_ - 1] = 1;
  }
  cin >> word;
  word_len = strlen(word);

  for(int i = 0; i < N; i++)
  {
    if(names[i] == word[0])
    {
      solve(i, 1);
    }
  }

  cout << paths << endl;
  return 0;
}