#include <cstdio>
#include <cmath>

#define MAX_SUM 209715200 //200 MB
#define MAX_N 20

#define f(i, n) for (int i = 0; i < n; ++i)
#define fo(i, a, b) for (int i = a; i <= b; ++i)

const char whoopi [] = "+-x";

int N, answ, real_answ;
long long _nums[MAX_N], nums[MAX_N];
char signs[MAX_N];

bool used[MAX_SUM];

void read ()
{
  scanf ("%d", &N);
  real_answ = pow(3, N - 1);
  f (i, N) scanf ("%d", &_nums[i]);
}

inline long long eval (int ind)
{
  int a;
  switch(signs[ind])
  {
    case '+':
      nums[ind] = nums[ind+1] = nums[ind] + nums[ind+1];
      break;
    case '-':
      nums[ind] = nums[ind+1] = nums[ind] - nums[ind+1];
      break;
    case 'x':
      nums[ind] = nums[ind+1] = nums[ind] * nums[ind+1];
      break;
  }
  //printf ("%d,%c,%d\n", ind, signs[ind], nums[ind]);
  answ = nums[ind];
  return nums[ind];
}

long long parse ()
{
  answ = 0;
  f (i, N) nums[i] = _nums[i];
  f (i, N-1) if (signs[i] == 'x') eval (i);
  f (i, N-1) if (signs[i] != 'x') eval (i);
}

void write ()
{
  printf ("%d\n", real_answ);
}

void solve (int lvl)
{
  if (lvl == N-1) {
    parse();
    if (!used[answ])  used[answ] = true;
    else  --real_answ;
  }
  else {
    f (i, 3) {
      signs[lvl++] = whoopi[i];
      solve(lvl);
      --lvl;
    }
  }
}

int main ()
{
  read();
  solve (0);
  write();
  return 0;
}
