#include <cstdio>
//#include <set>
//#include <ctime>

#define INF 9223372036854775807LL

#define ull long long

//using namespace std;

#define HASH_SIZE 2097152
#define HASH_MASK 2097151
struct hash_table {
	ull data[HASH_SIZE];
	
	hash_table() {
		for(int i = 0; i < HASH_SIZE; ++i) data[i] = INF;
	}
	inline bool check(ull n) {
		for(int i = n&HASH_MASK; data[i] != INF; i = (i+1)&HASH_MASK) {
			if(data[i] == n)
				return true;
		}
		return false;
	}
	inline void insert(ull n) {
		for(int i = n&HASH_MASK; 1; i = (i+1)&HASH_MASK) {
			if(data[i] == INF) {
				data[i] = n;
				return;
			}
		}
	}
} hash;
//set<ull> made;

int num[32], n, res;

#define HASH_TABLE

ull cval;
void rec(int pos, ull prev, int sgn) {
	if(pos == n-1) {
		cval += prev*sgn;
		
		/*#ifndef HASH_TABLE
		if(made.find(cval) == made.end()) {
			made.insert(cval);
			++res;
		}
		#else*/
		if(!hash.check(cval)) {
			hash.insert(cval);
			++res;
		}
		//#endif
		
		cval -= prev*sgn;
		return;
	}
	// PUT +
	cval += sgn*prev;
	rec(pos+1, num[pos+1], 1);
	// PUT -
	rec(pos+1, num[pos+1], -1);
	cval -= sgn*prev;
	// PUT *
	rec(pos+1, prev*num[pos+1], sgn);
}

int main() {
	//
	//long start = clock();
	scanf("%d", &n);
	for(int i = 0; i < n; ++i) scanf("%d", &num[i]);
	rec(0, num[0], 1);
	
	/*for(int i = 0; i < HASH_SIZE; ++i) {
		if(hash.data[i] != INF) {
			printf("%lld ", hash.data[i]);
		}
	}*/
	
	printf("%d\n", res);
	//printf("%d\n", clock()-start);
	return 0;
}
